<?php
  /**
   * @file
   * KerberosInterface class definition.
   */

  class KerberosInterface {

    private $realm; //Realm Name
    function __construct($realm_name) {
      $this->realm = $realm_name;
    }

    /**
     * @param string $username username
     * @param string $password password
     *
     * @return array -- tickets
     */
    function getTicket($username, $password) {
      $credential_cache = new KRB5CCache(); //init
      $credential_cache->setConfig('/etc/krb5.conf'); //default config for kerberos
      $principle = $username . '@' . $this->realm; //Construct principle from username and realm
      try {
        $credential_cache->initPassword($principle, $password);
      } catch (Exception $e) {
      }
      $entries = $credential_cache->getEntries(); //returns the same as running `klist`
      if (!$entries[0]) { //If there's no ticket at position 0, there are no tickets!
        watchdog('user', 'Kerberos Principle Ticket Request failed for user %user realm %realm.', array(
                                                                                                       '%user'     => $username,
                                                                                                       '%realm'    => $this->realm
                                                                                                  ));
        return NULL;
      }
      else {
        return $entries;
      }
    }
  }
